<html>
<head>
<title>OgreBillboardSet.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreBillboardSet.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreBillboardSet_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __BillboardSet_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __BillboardSet_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreRadixSort_8h.html">OgreRadixSort.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreResourceGroupManager_8h.html">OgreResourceGroupManager.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00053"></a><a class="code" href="group__Effects.html#ga37abc46b1f74f855e13334aa44f4ec5e">00053</a>     <span class="keyword">enum</span> <a class="code" href="group__Effects.html#ga37abc46b1f74f855e13334aa44f4ec5e" title="Enum covering what exactly a billboard&#39;s position means (center, top-left etc).">BillboardOrigin</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea2f0d9a0c7a6232a62819ba5f8088ce41">00055</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea2f0d9a0c7a6232a62819ba5f8088ce41">BBO_TOP_LEFT</a>,
<a name="l00056"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5eaec907934218991032b9b5f34a2d0d612">00056</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5eaec907934218991032b9b5f34a2d0d612">BBO_TOP_CENTER</a>,
<a name="l00057"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea183e54039d91c27835e5f7a066f8e485">00057</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea183e54039d91c27835e5f7a066f8e485">BBO_TOP_RIGHT</a>,
<a name="l00058"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea306c93ed76b358c9d6aef5b6ff413857">00058</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea306c93ed76b358c9d6aef5b6ff413857">BBO_CENTER_LEFT</a>,
<a name="l00059"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5eab17acd1195e321856b4e5a91ccb300a4">00059</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5eab17acd1195e321856b4e5a91ccb300a4">BBO_CENTER</a>,
<a name="l00060"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea4456ff76b26ecc97f3c34c2c709cf47b">00060</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea4456ff76b26ecc97f3c34c2c709cf47b">BBO_CENTER_RIGHT</a>,
<a name="l00061"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea6434f4b60d73ffb70c9ceefd1b5595dc">00061</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea6434f4b60d73ffb70c9ceefd1b5595dc">BBO_BOTTOM_LEFT</a>,
<a name="l00062"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea928ae6264de474f12e6e3ca00419ae2b">00062</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5ea928ae6264de474f12e6e3ca00419ae2b">BBO_BOTTOM_CENTER</a>,
<a name="l00063"></a><a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5eab67c73db2cf842dee641805c415901cb">00063</a>         <a class="code" href="group__Effects.html#gga37abc46b1f74f855e13334aa44f4ec5eab67c73db2cf842dee641805c415901cb">BBO_BOTTOM_RIGHT</a>
<a name="l00064"></a>00064     };
<a name="l00066"></a><a class="code" href="group__Effects.html#ga4f3a37a5b62f0a2ddda53f789e736cbd">00066</a>     <span class="keyword">enum</span> <a class="code" href="group__Effects.html#ga4f3a37a5b62f0a2ddda53f789e736cbd" title="The rotation type of billboard.">BillboardRotationType</a>
<a name="l00067"></a>00067     {
<a name="l00069"></a><a class="code" href="group__Effects.html#gga4f3a37a5b62f0a2ddda53f789e736cbda6a7f6b74eba56f5035dab96d94b07cad">00069</a>         <a class="code" href="group__Effects.html#gga4f3a37a5b62f0a2ddda53f789e736cbda6a7f6b74eba56f5035dab96d94b07cad" title="Rotate the billboard&#39;s vertices around their facing direction.">BBR_VERTEX</a>,
<a name="l00071"></a><a class="code" href="group__Effects.html#gga4f3a37a5b62f0a2ddda53f789e736cbdafc76d69a1ee25ad91871544eca2ca03f">00071</a>         <a class="code" href="group__Effects.html#gga4f3a37a5b62f0a2ddda53f789e736cbdafc76d69a1ee25ad91871544eca2ca03f" title="Rotate the billboard&#39;s texture coordinates.">BBR_TEXCOORD</a>
<a name="l00072"></a>00072     };
<a name="l00074"></a><a class="code" href="group__Effects.html#ga8a7bd8c019e0d8e7049e855847af2a1c">00074</a>     <span class="keyword">enum</span> <a class="code" href="group__Effects.html#ga8a7bd8c019e0d8e7049e855847af2a1c" title="The type of billboard to use.">BillboardType</a>
<a name="l00075"></a>00075     {
<a name="l00077"></a><a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1caafd0ef3ee3353703249e160930424b7d">00077</a>         <a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1caafd0ef3ee3353703249e160930424b7d" title="Standard point billboard (default), always faces the camera completely and is always upright...">BBT_POINT</a>,
<a name="l00079"></a><a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1cacfc7dcc9adc26c7b19c0a7047ee5ec1b">00079</a>         <a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1cacfc7dcc9adc26c7b19c0a7047ee5ec1b" title="Billboards are oriented around a shared direction vector (used as Y axis) and only rotate around this...">BBT_ORIENTED_COMMON</a>,
<a name="l00081"></a><a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1cabffcbe8d1e5e7d545d8f33762db75176">00081</a>         <a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1cabffcbe8d1e5e7d545d8f33762db75176" title="Billboards are oriented around their own direction vector (their own Y axis) and only rotate around t...">BBT_ORIENTED_SELF</a>,
<a name="l00083"></a><a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1ca9f88ba12ab6dd77447b73a0272147a4f">00083</a>         <a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1ca9f88ba12ab6dd77447b73a0272147a4f" title="Billboards are perpendicular to a shared direction vector (used as Z axis, the facing direction) and ...">BBT_PERPENDICULAR_COMMON</a>,
<a name="l00085"></a><a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1cab4c7cffc09bcc71b32cb6b4e5f758ee6">00085</a>         <a class="code" href="group__Effects.html#gga8a7bd8c019e0d8e7049e855847af2a1cab4c7cffc09bcc71b32cb6b4e5f758ee6" title="Billboards are perpendicular to their own direction vector (their own Z axis, the facing direction) a...">BBT_PERPENDICULAR_SELF</a>
<a name="l00086"></a>00086     };
<a name="l00087"></a>00087 
<a name="l00109"></a><a class="code" href="classOgre_1_1BillboardSet.html">00109</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00110"></a>00110     {
<a name="l00111"></a>00111     <span class="keyword">protected</span>:
<a name="l00114"></a>00114         <a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>();
<a name="l00115"></a>00115 
<a name="l00117"></a><a class="code" href="classOgre_1_1BillboardSet.html#a21dada64dba2f05e94eef6363c1ecdfb">00117</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1BillboardSet.html#a21dada64dba2f05e94eef6363c1ecdfb" title="Bounds of all billboards in this set.">mAABB</a>;
<a name="l00119"></a><a class="code" href="classOgre_1_1BillboardSet.html#a40c8144114a2ebea4f6f71427c3eab85">00119</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1BillboardSet.html#a40c8144114a2ebea4f6f71427c3eab85" title="Bounding radius.">mBoundingRadius</a>;
<a name="l00120"></a>00120 
<a name="l00122"></a><a class="code" href="classOgre_1_1BillboardSet.html#a37070ac95d91e966e283197c40a5df75">00122</a>         <a class="code" href="group__Effects.html#ga37abc46b1f74f855e13334aa44f4ec5e" title="Enum covering what exactly a billboard&#39;s position means (center, top-left etc).">BillboardOrigin</a> <a class="code" href="classOgre_1_1BillboardSet.html#a37070ac95d91e966e283197c40a5df75" title="Origin of each billboard.">mOriginType</a>;
<a name="l00124"></a><a class="code" href="classOgre_1_1BillboardSet.html#a76acd2ff4879a72924af77d9b61b16f6">00124</a>         <a class="code" href="group__Effects.html#ga4f3a37a5b62f0a2ddda53f789e736cbd" title="The rotation type of billboard.">BillboardRotationType</a> <a class="code" href="classOgre_1_1BillboardSet.html#a76acd2ff4879a72924af77d9b61b16f6" title="Rotation type of each billboard.">mRotationType</a>;
<a name="l00125"></a>00125 
<a name="l00127"></a><a class="code" href="classOgre_1_1BillboardSet.html#aaa690c2b7570aa34dc04365c68cd9d5a">00127</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1BillboardSet.html#aaa690c2b7570aa34dc04365c68cd9d5a" title="Default width of each billboard.">mDefaultWidth</a>;
<a name="l00129"></a><a class="code" href="classOgre_1_1BillboardSet.html#a03367c07a3dd40d7621edca624a45722">00129</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1BillboardSet.html#a03367c07a3dd40d7621edca624a45722" title="Default height of each billboard.">mDefaultHeight</a>;
<a name="l00130"></a>00130 
<a name="l00132"></a><a class="code" href="classOgre_1_1BillboardSet.html#aca94537d9a5be4d08256e5a75d56314f">00132</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1BillboardSet.html#aca94537d9a5be4d08256e5a75d56314f" title="Name of the material to use.">mMaterialName</a>;
<a name="l00134"></a><a class="code" href="classOgre_1_1BillboardSet.html#a8debafdc41b0368bab01041faf5fc50b">00134</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1BillboardSet.html#a8debafdc41b0368bab01041faf5fc50b" title="Pointer to the material to use.">mMaterial</a>;
<a name="l00135"></a>00135 
<a name="l00137"></a><a class="code" href="classOgre_1_1BillboardSet.html#a645c0927a0894a1b94841a3acb8d7475">00137</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a645c0927a0894a1b94841a3acb8d7475" title="True if no billboards in this set have been resized - greater efficiency.">mAllDefaultSize</a>;
<a name="l00138"></a>00138 
<a name="l00140"></a><a class="code" href="classOgre_1_1BillboardSet.html#a29320c5ecc37ea707d0b52a61cd0ffdb">00140</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a29320c5ecc37ea707d0b52a61cd0ffdb" title="Flag indicating whether to autoextend pool.">mAutoExtendPool</a>;
<a name="l00141"></a>00141 
<a name="l00143"></a><a class="code" href="classOgre_1_1BillboardSet.html#a644169483771c7ae514745059a343157">00143</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a644169483771c7ae514745059a343157" title="Flag indicating whether the billboards has to be sorted.">mSortingEnabled</a>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145         <span class="comment">// Use &#39;true&#39; billboard to cam position facing, rather than camera direcion</span>
<a name="l00146"></a><a class="code" href="classOgre_1_1BillboardSet.html#afcef064840b97ef0e68e03efe00cfcd2">00146</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#afcef064840b97ef0e68e03efe00cfcd2">mAccurateFacing</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classOgre_1_1BillboardSet.html#a6ed1159236d6179b3044486ce34eaed3">00148</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a6ed1159236d6179b3044486ce34eaed3">mAllDefaultRotation</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1BillboardSet.html#a70a9735f46272fc1ca12c5f31c8d64ab">00149</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a70a9735f46272fc1ca12c5f31c8d64ab">mWorldSpace</a>;
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="classOgre_1_1BillboardSet.html#afeedc8986a520b00d2ee001b3c04e6e8">00151</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;Billboard*&gt;::type</a> <a class="code" href="classOgre_1_1BillboardSet.html#afeedc8986a520b00d2ee001b3c04e6e8">ActiveBillboardList</a>;
<a name="l00152"></a><a class="code" href="classOgre_1_1BillboardSet.html#ad17005413ce52979083a6bec0bc4a842">00152</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;Billboard*&gt;::type</a> <a class="code" href="classOgre_1_1BillboardSet.html#ad17005413ce52979083a6bec0bc4a842">FreeBillboardList</a>;
<a name="l00153"></a><a class="code" href="classOgre_1_1BillboardSet.html#a571433a06b19272e1e8651e2064ca960">00153</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Billboard*&gt;::type</a> <a class="code" href="classOgre_1_1BillboardSet.html#a571433a06b19272e1e8651e2064ca960">BillboardPool</a>;
<a name="l00154"></a>00154 
<a name="l00163"></a><a class="code" href="classOgre_1_1BillboardSet.html#a70a83d233016a63bda5fb9a9c71570b6">00163</a>         <a class="code" href="classOgre_1_1BillboardSet.html#afeedc8986a520b00d2ee001b3c04e6e8">ActiveBillboardList</a> <a class="code" href="classOgre_1_1BillboardSet.html#a70a83d233016a63bda5fb9a9c71570b6" title="Active billboard list.">mActiveBillboards</a>;
<a name="l00164"></a>00164 
<a name="l00172"></a><a class="code" href="classOgre_1_1BillboardSet.html#a47b8335cd4fce4f4482be3c063f6a693">00172</a>         <a class="code" href="classOgre_1_1BillboardSet.html#ad17005413ce52979083a6bec0bc4a842">FreeBillboardList</a> <a class="code" href="classOgre_1_1BillboardSet.html#a47b8335cd4fce4f4482be3c063f6a693" title="Free billboard queue.">mFreeBillboards</a>;
<a name="l00173"></a>00173 
<a name="l00178"></a><a class="code" href="classOgre_1_1BillboardSet.html#ae3d1b2ef6a53b53a22a303770c0f61fd">00178</a>         <a class="code" href="classOgre_1_1BillboardSet.html#a571433a06b19272e1e8651e2064ca960">BillboardPool</a> <a class="code" href="classOgre_1_1BillboardSet.html#ae3d1b2ef6a53b53a22a303770c0f61fd" title="Pool of billboard instances for use and reuse in the active billboard list.">mBillboardPool</a>;
<a name="l00179"></a>00179 
<a name="l00181"></a><a class="code" href="classOgre_1_1BillboardSet.html#a3fbbf176c278681ccbf0b0765fbd28f0">00181</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="classOgre_1_1BillboardSet.html#a3fbbf176c278681ccbf0b0765fbd28f0" title="The vertex position data for all billboards in this set.">mVertexData</a>;
<a name="l00183"></a><a class="code" href="classOgre_1_1BillboardSet.html#a4e9d2caa6346ac6cff825ae919082469">00183</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1BillboardSet.html#a4e9d2caa6346ac6cff825ae919082469" title="Shortcut to main buffer (positions, colours, texture coords)">mMainBuf</a>;
<a name="l00185"></a><a class="code" href="classOgre_1_1BillboardSet.html#a53c649df167b329508eb9140df03dc6f">00185</a>         <span class="keywordtype">float</span>* <a class="code" href="classOgre_1_1BillboardSet.html#a53c649df167b329508eb9140df03dc6f" title="Locked pointer to buffer.">mLockPtr</a>;
<a name="l00189"></a><a class="code" href="classOgre_1_1BillboardSet.html#aedfa9402478a80490cd0cafd5524d4ce">00189</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mVOffset[4];
<a name="l00191"></a><a class="code" href="classOgre_1_1BillboardSet.html#a217565744ae1410cd675c459a3693d5f">00191</a>         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <a class="code" href="classOgre_1_1BillboardSet.html#a217565744ae1410cd675c459a3693d5f" title="Current camera.">mCurrentCamera</a>;
<a name="l00192"></a>00192         <span class="comment">// Parametric offsets of origin</span>
<a name="l00193"></a><a class="code" href="classOgre_1_1BillboardSet.html#a4b21eae7413ee75d8f4a48a82578fac7">00193</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mLeftOff, mRightOff, <a class="code" href="classOgre_1_1BillboardSet.html#a4b21eae7413ee75d8f4a48a82578fac7">mTopOff</a>, mBottomOff;
<a name="l00194"></a>00194         <span class="comment">// Camera axes in billboard space</span>
<a name="l00195"></a><a class="code" href="classOgre_1_1BillboardSet.html#a9662b97b49c956ba22aeaf621c65c9c7">00195</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mCamX, <a class="code" href="classOgre_1_1BillboardSet.html#a9662b97b49c956ba22aeaf621c65c9c7">mCamY</a>;
<a name="l00196"></a>00196         <span class="comment">// Camera direction in billboard space</span>
<a name="l00197"></a><a class="code" href="classOgre_1_1BillboardSet.html#a61b73ee1e8e3acc3e338b7e66799b613">00197</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1BillboardSet.html#a61b73ee1e8e3acc3e338b7e66799b613">mCamDir</a>;
<a name="l00198"></a>00198         <span class="comment">// Camera orientation in billboard space</span>
<a name="l00199"></a><a class="code" href="classOgre_1_1BillboardSet.html#aff769bb8afd602f0059e13ef65b25f4a">00199</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1BillboardSet.html#aff769bb8afd602f0059e13ef65b25f4a">mCamQ</a>;
<a name="l00200"></a>00200         <span class="comment">// Camera position in billboard space</span>
<a name="l00201"></a><a class="code" href="classOgre_1_1BillboardSet.html#aed3b46fee6156d09a8e1f08b26646789">00201</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1BillboardSet.html#aed3b46fee6156d09a8e1f08b26646789">mCamPos</a>;
<a name="l00202"></a>00202 
<a name="l00204"></a>00204         <span class="comment">//unsigned short* mIndexes;</span>
<a name="l00205"></a><a class="code" href="classOgre_1_1BillboardSet.html#a6e9d3ad0a93d6f0a7de137cd79be6491">00205</a>         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* <a class="code" href="classOgre_1_1BillboardSet.html#a6e9d3ad0a93d6f0a7de137cd79be6491" title="The vertex index data for all billboards in this set (1 set only)">mIndexData</a>;
<a name="l00206"></a>00206 
<a name="l00208"></a><a class="code" href="classOgre_1_1BillboardSet.html#aa87463489d148189d0a3044215a387ec">00208</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#aa87463489d148189d0a3044215a387ec" title="Flag indicating whether each billboard should be culled separately (default: false)">mCullIndividual</a>;
<a name="l00209"></a>00209 
<a name="l00210"></a><a class="code" href="classOgre_1_1BillboardSet.html#a73b19d7977d3e0ef24ad89c3b19e8da5">00210</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt; Ogre::FloatRect &gt;::type</a> <a class="code" href="classOgre_1_1BillboardSet.html#a73b19d7977d3e0ef24ad89c3b19e8da5">TextureCoordSets</a>;
<a name="l00211"></a><a class="code" href="classOgre_1_1BillboardSet.html#a45b53ca2e429e890312692083d37e6be">00211</a>         <a class="code" href="classOgre_1_1BillboardSet.html#a73b19d7977d3e0ef24ad89c3b19e8da5">TextureCoordSets</a> <a class="code" href="classOgre_1_1BillboardSet.html#a45b53ca2e429e890312692083d37e6be">mTextureCoords</a>;
<a name="l00212"></a>00212 
<a name="l00214"></a><a class="code" href="classOgre_1_1BillboardSet.html#a2ef18ece809efc41d14466c1e1b08ebd">00214</a>         <a class="code" href="group__Effects.html#ga8a7bd8c019e0d8e7049e855847af2a1c" title="The type of billboard to use.">BillboardType</a> <a class="code" href="classOgre_1_1BillboardSet.html#a2ef18ece809efc41d14466c1e1b08ebd" title="The type of billboard to render.">mBillboardType</a>;
<a name="l00215"></a>00215 
<a name="l00217"></a><a class="code" href="classOgre_1_1BillboardSet.html#a17df519563699c9b237228f678e981d8">00217</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1BillboardSet.html#a17df519563699c9b237228f678e981d8" title="Common direction for billboards of type BBT_ORIENTED_COMMON and BBT_PERPENDICULAR_COMMON.">mCommonDirection</a>;
<a name="l00219"></a><a class="code" href="classOgre_1_1BillboardSet.html#a0e2e166c37dc148f921c62fc6c1a237b">00219</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1BillboardSet.html#a0e2e166c37dc148f921c62fc6c1a237b" title="Common up-vector for billboards of type BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON.">mCommonUpVector</a>;
<a name="l00220"></a>00220 
<a name="l00222"></a>00222         <span class="keyword">inline</span> <span class="keywordtype">bool</span> billboardVisible(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>&amp; bill);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224         <span class="comment">// Number of visible billboards (will be == getNumBillboards if mCullIndividual == false)</span>
<a name="l00225"></a><a class="code" href="classOgre_1_1BillboardSet.html#ae2e2099f18f8a05897c154d17a1e243f">00225</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1BillboardSet.html#ae2e2099f18f8a05897c154d17a1e243f">mNumVisibleBillboards</a>;
<a name="l00226"></a>00226 
<a name="l00228"></a>00228         <span class="keyword">virtual</span> <span class="keywordtype">void</span> increasePool(<span class="keywordtype">size_t</span> size);
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231         <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00232"></a>00232         <span class="comment">// The internal methods which follow are here to allow maximum flexibility as to </span>
<a name="l00233"></a>00233         <span class="comment">//  when various components of the calculation are done. Depending on whether the</span>
<a name="l00234"></a>00234         <span class="comment">//  billboards are of fixed size and whether they are point or oriented type will</span>
<a name="l00235"></a>00235         <span class="comment">//  determine how much calculation has to be done per-billboard. NOT a one-size fits all approach.</span>
<a name="l00236"></a>00236         <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00241"></a>00241 <span class="comment"></span>        <span class="keywordtype">void</span> genBillboardAxes(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* pX, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> *pY, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>* pBill = 0);
<a name="l00242"></a>00242 
<a name="l00245"></a>00245         <span class="keywordtype">void</span> getParametricOffsets(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; bottom);
<a name="l00246"></a>00246 
<a name="l00251"></a>00251         <span class="keywordtype">void</span> genVertices(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* <span class="keyword">const</span> offsets, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>&amp; pBillboard);
<a name="l00252"></a>00252 
<a name="l00260"></a>00260         <span class="keywordtype">void</span> genVertOffsets(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> inleft, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> inright, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> intop, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> inbottom,
<a name="l00261"></a>00261             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height,
<a name="l00262"></a>00262             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; x, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; y, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* pDestVec);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00266"></a><a class="code" href="structOgre_1_1BillboardSet_1_1SortByDirectionFunctor.html">00266</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1BillboardSet_1_1SortByDirectionFunctor.html" title="Sort by direction functor.">SortByDirectionFunctor</a>
<a name="l00267"></a>00267         {
<a name="l00269"></a><a class="code" href="structOgre_1_1BillboardSet_1_1SortByDirectionFunctor.html#a176f7142382739d74eef63c9f26beee2">00269</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1BillboardSet_1_1SortByDirectionFunctor.html#a176f7142382739d74eef63c9f26beee2" title="Direction to sort in.">sortDir</a>;
<a name="l00270"></a>00270 
<a name="l00271"></a>00271             <a class="code" href="structOgre_1_1BillboardSet_1_1SortByDirectionFunctor.html" title="Sort by direction functor.">SortByDirectionFunctor</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dir);
<a name="l00272"></a>00272             <span class="keywordtype">float</span> operator()(<a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>* bill) <span class="keyword">const</span>;
<a name="l00273"></a>00273         };
<a name="l00274"></a>00274 
<a name="l00276"></a><a class="code" href="structOgre_1_1BillboardSet_1_1SortByDistanceFunctor.html">00276</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1BillboardSet_1_1SortByDistanceFunctor.html" title="Sort by distance functor.">SortByDistanceFunctor</a>
<a name="l00277"></a>00277         {
<a name="l00279"></a><a class="code" href="structOgre_1_1BillboardSet_1_1SortByDistanceFunctor.html#aa9b57d6caf0889fa7ec77065bbd79269">00279</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1BillboardSet_1_1SortByDistanceFunctor.html#aa9b57d6caf0889fa7ec77065bbd79269" title="Position to sort in.">sortPos</a>;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281             <a class="code" href="structOgre_1_1BillboardSet_1_1SortByDistanceFunctor.html" title="Sort by distance functor.">SortByDistanceFunctor</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos);
<a name="l00282"></a>00282             <span class="keywordtype">float</span> operator()(<a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>* bill) <span class="keyword">const</span>;
<a name="l00283"></a>00283         };
<a name="l00284"></a>00284 
<a name="l00285"></a><a class="code" href="classOgre_1_1BillboardSet.html#ac50fb47c1f058c3554a94a82157b5285">00285</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1RadixSort.html">RadixSort&lt;ActiveBillboardList, Billboard*, float&gt;</a> <a class="code" href="classOgre_1_1BillboardSet.html#ac50fb47c1f058c3554a94a82157b5285">mRadixSorter</a>;
<a name="l00286"></a>00286 
<a name="l00288"></a><a class="code" href="classOgre_1_1BillboardSet.html#af0d87968f9a69a269a571ceeeb593caa">00288</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#af0d87968f9a69a269a571ceeeb593caa" title="Use point rendering?">mPointRendering</a>;
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292     <span class="keyword">private</span>:
<a name="l00294"></a><a class="code" href="classOgre_1_1BillboardSet.html#a6785a73795790343989753a44bfc72dc">00294</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a6785a73795790343989753a44bfc72dc" title="Flag indicating whether the HW buffers have been created.">mBuffersCreated</a>;
<a name="l00296"></a><a class="code" href="classOgre_1_1BillboardSet.html#aad0d5e014455a102ce89d9abc005a6ae">00296</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1BillboardSet.html#aad0d5e014455a102ce89d9abc005a6ae" title="The number of billboard in the pool.">mPoolSize</a>;
<a name="l00298"></a><a class="code" href="classOgre_1_1BillboardSet.html#a9df2e7e498ff697ac99b1a0302114b79">00298</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a9df2e7e498ff697ac99b1a0302114b79" title="Is external billboard data in use?">mExternalData</a>;
<a name="l00300"></a><a class="code" href="classOgre_1_1BillboardSet.html#aad21adb6664872c211ed996cc2508e71">00300</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#aad21adb6664872c211ed996cc2508e71" title="Tell if vertex buffer should be update automatically.">mAutoUpdate</a>;
<a name="l00302"></a><a class="code" href="classOgre_1_1BillboardSet.html#aac010067f8c8a4f0926ce79b90dc7222">00302</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#aac010067f8c8a4f0926ce79b90dc7222" title="True if the billboard data changed. Will cause vertex buffer update.">mBillboardDataChanged</a>;
<a name="l00303"></a>00303 
<a name="l00306"></a>00306         <span class="keywordtype">void</span> _createBuffers(<span class="keywordtype">void</span>);
<a name="l00309"></a>00309         <span class="keywordtype">void</span> _destroyBuffers(<span class="keywordtype">void</span>);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311     <span class="keyword">public</span>:
<a name="l00312"></a>00312 
<a name="l00332"></a>00332         <a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> poolSize = 20, 
<a name="l00333"></a>00333             <span class="keywordtype">bool</span> externalDataSource = <span class="keyword">false</span>);
<a name="l00334"></a>00334 
<a name="l00335"></a>00335         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>();
<a name="l00336"></a>00336 
<a name="l00354"></a>00354         <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>* createBillboard(
<a name="l00355"></a>00355             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; position,
<a name="l00356"></a>00356             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a> );
<a name="l00357"></a>00357 
<a name="l00379"></a>00379         <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>* createBillboard(
<a name="l00380"></a>00380             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z,
<a name="l00381"></a>00381             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a> );
<a name="l00382"></a>00382 
<a name="l00385"></a>00385         <span class="keyword">virtual</span> <span class="keywordtype">int</span> getNumBillboards(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00386"></a>00386 
<a name="l00401"></a>00401         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAutoextend(<span class="keywordtype">bool</span> autoextend);
<a name="l00402"></a>00402 
<a name="l00407"></a>00407         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getAutoextend(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00408"></a>00408 
<a name="l00412"></a>00412         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSortingEnabled(<span class="keywordtype">bool</span> sortenable);
<a name="l00413"></a>00413 
<a name="l00418"></a>00418         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getSortingEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00419"></a>00419 
<a name="l00430"></a>00430         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPoolSize(<span class="keywordtype">size_t</span> size);
<a name="l00431"></a>00431 
<a name="l00438"></a>00438         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getPoolSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00443"></a>00443         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clear();
<a name="l00444"></a>00444 
<a name="l00456"></a>00456         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>* getBillboard(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;
<a name="l00457"></a>00457 
<a name="l00462"></a>00462         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeBillboard(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00463"></a>00463 
<a name="l00468"></a>00468         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeBillboard(<a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>* pBill);
<a name="l00469"></a>00469 
<a name="l00481"></a>00481         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBillboardOrigin(<a class="code" href="group__Effects.html#ga37abc46b1f74f855e13334aa44f4ec5e" title="Enum covering what exactly a billboard&#39;s position means (center, top-left etc).">BillboardOrigin</a> origin);
<a name="l00482"></a>00482 
<a name="l00487"></a>00487         <span class="keyword">virtual</span> <a class="code" href="group__Effects.html#ga37abc46b1f74f855e13334aa44f4ec5e" title="Enum covering what exactly a billboard&#39;s position means (center, top-left etc).">BillboardOrigin</a> getBillboardOrigin(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00488"></a>00488 
<a name="l00498"></a>00498         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBillboardRotationType(<a class="code" href="group__Effects.html#ga4f3a37a5b62f0a2ddda53f789e736cbd" title="The rotation type of billboard.">BillboardRotationType</a> rotationType);
<a name="l00499"></a>00499 
<a name="l00504"></a>00504         <span class="keyword">virtual</span> <a class="code" href="group__Effects.html#ga4f3a37a5b62f0a2ddda53f789e736cbd" title="The rotation type of billboard.">BillboardRotationType</a> getBillboardRotationType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00505"></a>00505 
<a name="l00516"></a>00516         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDefaultDimensions(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00517"></a>00517 
<a name="l00519"></a>00519         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDefaultWidth(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width);
<a name="l00521"></a>00521         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getDefaultWidth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00523"></a>00523         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDefaultHeight(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00525"></a>00525         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getDefaultHeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00526"></a>00526 
<a name="l00531"></a>00531         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMaterialName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a70da3137e703c147b98fbfbbebfbf023" title="Special resource group name which causes resource group to be automatically determined based on searc...">ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME</a> );
<a name="l00532"></a>00532 
<a name="l00536"></a>00536         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00537"></a>00537 
<a name="l00542"></a>00542         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00543"></a>00543 
<a name="l00549"></a>00549         <span class="keywordtype">void</span> beginBillboards(<span class="keywordtype">size_t</span> numBillboards = 0);
<a name="l00551"></a>00551         <span class="keywordtype">void</span> injectBillboard(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>&amp; bb);
<a name="l00553"></a>00553         <span class="keywordtype">void</span> endBillboards(<span class="keywordtype">void</span>);
<a name="l00559"></a>00559         <span class="keywordtype">void</span> setBounds(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius);
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00566"></a>00566         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00567"></a>00567 
<a name="l00572"></a>00572         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00577"></a>00577         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00578"></a>00578 
<a name="l00583"></a>00583         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00584"></a>00584 
<a name="l00589"></a>00589         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMaterial( <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; material );
<a name="l00590"></a>00590 
<a name="l00595"></a>00595         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00596"></a>00596 
<a name="l00601"></a>00601         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00602"></a>00602 
<a name="l00605"></a>00605         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyBillboardResized(<span class="keywordtype">void</span>);
<a name="l00606"></a>00606 
<a name="l00609"></a>00609         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyBillboardRotated(<span class="keywordtype">void</span>);
<a name="l00610"></a>00610 
<a name="l00612"></a>00612         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getCullIndividually(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00633"></a>00633         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCullIndividually(<span class="keywordtype">bool</span> cullIndividual);
<a name="l00634"></a>00634 
<a name="l00655"></a>00655         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBillboardType(<a class="code" href="group__Effects.html#ga8a7bd8c019e0d8e7049e855847af2a1c" title="The type of billboard to use.">BillboardType</a> bbt);
<a name="l00656"></a>00656 
<a name="l00658"></a>00658         <span class="keyword">virtual</span> <a class="code" href="group__Effects.html#ga8a7bd8c019e0d8e7049e855847af2a1c" title="The type of billboard to use.">BillboardType</a> getBillboardType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00659"></a>00659 
<a name="l00674"></a>00674         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCommonDirection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00675"></a>00675 
<a name="l00677"></a>00677         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getCommonDirection(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00678"></a>00678 
<a name="l00693"></a>00693         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCommonUpVector(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00694"></a>00694 
<a name="l00696"></a>00696         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getCommonUpVector(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00697"></a>00697         
<a name="l00711"></a><a class="code" href="classOgre_1_1BillboardSet.html#a1a93d395e49678433c70a8b3aa1f06a4">00711</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1BillboardSet.html#a1a93d395e49678433c70a8b3aa1f06a4" title="Sets whether or not billboards should use an &#39;accurate&#39; facing model based on the vector from each bi...">setUseAccurateFacing</a>(<span class="keywordtype">bool</span> acc) { mAccurateFacing = acc; }
<a name="l00716"></a><a class="code" href="classOgre_1_1BillboardSet.html#aec830055e293cdcf40f40bc8a0a704c4">00716</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#aec830055e293cdcf40f40bc8a0a704c4" title="Gets whether or not billboards use an &#39;accurate&#39; facing model based on the vector from each billboard...">getUseAccurateFacing</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAccurateFacing; }
<a name="l00717"></a>00717 
<a name="l00719"></a>00719         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00720"></a>00720 
<a name="l00722"></a>00722         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00723"></a>00723 
<a name="l00725"></a>00725         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateBounds(<span class="keywordtype">void</span>);
<a name="l00727"></a>00727         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00728"></a>00728 
<a name="l00730"></a>00730         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00731"></a>00731             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00732"></a>00732 
<a name="l00734"></a>00734         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _sortBillboards( <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00735"></a>00735 
<a name="l00737"></a>00737         <span class="keyword">virtual</span> <a class="code" href="group__General.html#ga73dc0089e326fa37f93a30bf67ba7e3a" title="Sort mode for billboard-set and particle-system.">SortMode</a> _getSortMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00738"></a>00738 
<a name="l00744"></a><a class="code" href="classOgre_1_1BillboardSet.html#a76b76f1f5dbf25e23daa6a681a6c23d9">00744</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1BillboardSet.html#a76b76f1f5dbf25e23daa6a681a6c23d9" title="Sets whether billboards should be treated as being in world space.">setBillboardsInWorldSpace</a>(<span class="keywordtype">bool</span> ws) { mWorldSpace = ws; }
<a name="l00745"></a>00745 
<a name="l00773"></a>00773         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTextureCoords( <a class="code" href="structOgre_1_1TRect.html">Ogre::FloatRect</a> <span class="keyword">const</span> * coords, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> numCoords );
<a name="l00774"></a>00774 
<a name="l00788"></a>00788         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTextureStacksAndSlices( <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> stacks, <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> slices );
<a name="l00789"></a>00789 
<a name="l00796"></a>00796         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1TRect.html">Ogre::FloatRect</a> <span class="keyword">const</span> * getTextureCoords( <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> * oNumCoords );
<a name="l00797"></a>00797 
<a name="l00826"></a>00826         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPointRenderingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00827"></a>00827 
<a name="l00829"></a><a class="code" href="classOgre_1_1BillboardSet.html#ac76edd617e14d051d4013f1f5ec52e35">00829</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isPointRenderingEnabled(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00830"></a>00830 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mPointRendering; }
<a name="l00831"></a>00831         
<a name="l00833"></a>00833         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getTypeFlags(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00834"></a>00834 
<a name="l00844"></a>00844         <span class="keywordtype">void</span> setAutoUpdate(<span class="keywordtype">bool</span> autoUpdate);
<a name="l00845"></a>00845 
<a name="l00847"></a><a class="code" href="classOgre_1_1BillboardSet.html#a71fb65815230daccf80f8a9ddc10aa8f">00847</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardSet.html#a71fb65815230daccf80f8a9ddc10aa8f" title="Return the auto update state of this billboard set.">getAutoUpdate</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAutoUpdate; }
<a name="l00848"></a>00848 
<a name="l00853"></a><a class="code" href="classOgre_1_1BillboardSet.html#aa0306902ff175409c288e8f7be67f999">00853</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1BillboardSet.html#aa0306902ff175409c288e8f7be67f999" title="When billboard set is not auto updating its GPU buffer, the user is responsible to inform it about an...">notifyBillboardDataChanged</a>(<span class="keywordtype">void</span>) { mBillboardDataChanged = <span class="keyword">true</span>; }
<a name="l00854"></a>00854 
<a name="l00855"></a>00855     };
<a name="l00856"></a>00856 
<a name="l00858"></a><a class="code" href="classOgre_1_1BillboardSetFactory.html">00858</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BillboardSetFactory.html" title="Factory object for creating BillboardSet instances.">BillboardSetFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>
<a name="l00859"></a>00859     {
<a name="l00860"></a>00860     <span class="keyword">protected</span>:
<a name="l00861"></a>00861         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* createInstanceImpl( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params);
<a name="l00862"></a>00862     <span class="keyword">public</span>:
<a name="l00863"></a><a class="code" href="classOgre_1_1BillboardSetFactory.html#ae9a4de2651c1585f849122d117b607e2">00863</a>         <a class="code" href="classOgre_1_1BillboardSetFactory.html#ae9a4de2651c1585f849122d117b607e2">BillboardSetFactory</a>() {}
<a name="l00864"></a><a class="code" href="classOgre_1_1BillboardSetFactory.html#a09ec91b5f9f262975eee3178c4525699">00864</a>         <a class="code" href="classOgre_1_1BillboardSetFactory.html#a09ec91b5f9f262975eee3178c4525699">~BillboardSetFactory</a>() {}
<a name="l00865"></a>00865 
<a name="l00866"></a><a class="code" href="classOgre_1_1BillboardSetFactory.html#a9973fc338f04f72c1a823f1a6e858b63">00866</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1BillboardSetFactory.html#a9973fc338f04f72c1a823f1a6e858b63">FACTORY_TYPE_NAME</a>;
<a name="l00867"></a>00867 
<a name="l00868"></a>00868         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00869"></a>00869         <span class="keywordtype">void</span> destroyInstance( <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj);  
<a name="l00870"></a>00870 
<a name="l00871"></a>00871     };
<a name="l00875"></a>00875 }
<a name="l00876"></a>00876 
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
